﻿Public Class Form1

    '*************************************************************
    ' WIN32関連
    '*************************************************************

    Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Integer)
    Private Declare Function GetComputerName Lib "KERNEL32" Alias "GetComputerNameA" (ByVal Buffer As String, ByRef Size_Renamed As Integer) As Integer
    Private Declare Function WritePrivateProfileString Lib "KERNEL32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String) As Boolean
    Private Declare Function MoveFile Lib "KERNEL32" Alias "MoveFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String) As Integer

    '*************************************************************
    ' 定数定義
    '*************************************************************

    Const s_cstTITLE As String = "クライアント側プログラム２" 'メッセージボックスのタイトル用

    Const CLIAPR2_FLD_DATA As String = "CliApr2Dat" ' このプログラムのデータフォルダ
    Const CLIAPR2_FLD_OUTFOLDER As String = "CliApr2OutFolder" ' プリンタドライバ: ファイル出力フォルダ
    Const CLIAPR2_DOCNAME As String = "CLIAPR2" ' プリンタドライバ: ドキュメント名

    '*************************************************************
    ' 変数定義
    '*************************************************************

    Dim s_bPgmRun As Boolean ' プログラム起動フラグ

    Dim s_strPgmData As String ' このプログラムのデータフォルダ
    Dim s_strOutFolder As String ' プリンタドライバ: ファイル出力フォルダ

    Dim s_bGetOldReg As Boolean ' プリンタドライバ動作設定値(レジストリ) の更新
    Dim s_strOldOutFolder As String ' レジストリ保存: ファイル出力フォルダ
    Dim s_strOldDocName As String ' レジストリ保存: ドキュメント名
    Dim s_lOldExecFlag As Integer ' レジストリ保存: プログラム実行フラグ

    Dim s_strTIFFFILE As String ' FAX原稿( TIFFファイル )
    Dim s_strCompName As String ' コンピュータ名

    '*************************************************************
    ' プログラム起動
    '*************************************************************

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim strCNameBuff As String
        strCNameBuff = New String(Chr(0), 16)

        '-------------------------------------------------------------
        ' プログラム起動フラグリセット

        s_bPgmRun = False

        '-------------------------------------------------------------
        ' プログラムの２重起動不可

        If (UBound(Diagnostics.Process.GetProcessesByName(Diagnostics.Process.GetCurrentProcess.ProcessName)) > 0) Then
            MsgBox("すでに「" & s_cstTITLE & "」は起動されています。", MsgBoxStyle.Critical, s_cstTITLE)
            Me.Close()
            End
        End If

        '-------------------------------------------------------------
        ' プログラム起動

        s_bPgmRun = True

        '-------------------------------------------------------------
        ' 初期設定

        s_strPgmData = "" ' このプログラムのデータフォルダ
        s_strOutFolder = "" ' プリンタドライバ: ファイル出力フォルダ
        s_bGetOldReg = False ' プリンタドライバ動作設定値(レジストリ) の更新
        s_strOldOutFolder = "" ' レジストリ保存: ファイル出力フォルダ
        s_strOldDocName = "" ' レジストリ保存: ドキュメント名
        s_lOldExecFlag = 0 ' レジストリ保存: プログラム実行フラグ
        s_strTIFFFILE = "" ' FAX原稿( TIFFファイル )

        '-------------------------------------------------------------
        ' このプログラムのデータフォルダ設定

        s_strPgmData = "C:\" & CLIAPR2_FLD_DATA
        If Dir(s_strPgmData, FileAttribute.Directory) = "" Then
            Call MkDir(s_strPgmData)
        End If
        s_strOutFolder = "C:\" & CLIAPR2_FLD_OUTFOLDER
        If Dir(s_strOutFolder, FileAttribute.Directory) = "" Then
            Call MkDir(s_strOutFolder)
        End If

        '-------------------------------------------------------------
        ' プリンタドライバ動作設定値(レジストリ)をこのプログラム用に書き換えます。
        '-------------------------------------------------------------

        '-------------------------------------------------------------
        ' プリンタドライバ動作設定値(レジストリ)の保存

        ' レジストリ保存: ファイル出力フォルダ
        s_strOldOutFolder = SFCSENV_GetSvcRegPathString("OutFolder", "")
        ' レジストリ保存: ドキュメント名
        s_strOldDocName = SFCSENV_GetSvcRegString("DocName", "")
        ' レジストリ保存: プログラム実行フラグ
        s_lOldExecFlag = SFCSENV_GetSvcRegInt("ExecFlag", 0)

        '-------------------------------------------------------------
        ' プリンタドライバ動作設定値(レジストリ)の書き換え

        s_bGetOldReg = SFCSENV_WriteSvcRegPathString("OutFolder", s_strOutFolder)
        If s_bGetOldReg = True Then
            Call SFCSENV_WriteSvcRegString("DocName", CLIAPR2_DOCNAME)
            Call SFCSENV_WriteRegInt("ExecFlag", 0)
        End If
        If s_bGetOldReg = False Then
            ' レジストリの書き換えに失敗
            MsgBox("このプログラムは一時的にSTARFAXの動作設定レジストリを書き換える為、" & vbCrLf & "管理者権限がない場合、実行できません", MsgBoxStyle.Critical, s_cstTITLE)
            Me.Close()
            End
        End If

        '-------------------------------------------------------------
        ' コンピュータ名の取得

        If GetComputerName(strCNameBuff, 16) <> 0 Then
            s_strCompName = Microsoft.VisualBasic.Left(strCNameBuff, InStr(strCNameBuff, vbNullChar) - 1)
        Else
            MsgBox("コンピュータ名を取得できませんでした。", MsgBoxStyle.Critical, s_cstTITLE)
            Me.Close()
            End
        End If

        '-------------------------------------------------------------
        ' 各種コントロールの初期設定

        '-------------------------------------------------------------
        ' 共有フォルダ読み込み

        TextCMNFOLDER.Text = GetSetting("CliApr2", "Setting", "CMNFOLDER", "\\サーバーマシン名\Work")

    End Sub

    '*************************************************************
    ' プログラム終了
    '*************************************************************

    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        procEnd()   '終了処理

    End Sub

    '*************************************************************
    ' キャンセルボタン: クリック
    '*************************************************************

    Private Sub CommandCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandCancel.Click

        procEnd()   '終了処理

        End

    End Sub

    '-------------------------------------------------------------
    ' 終了処理
    '-------------------------------------------------------------

    Private Sub procEnd()

        '-------------------------------------------------------------
        ' プログラム起動？

        If s_bPgmRun = True Then

            '-------------------------------------------------------------
            ' FAX原稿( TIFFファイル )のクリア

            If s_strTIFFFILE <> "" Then
                Kill(s_strTIFFFILE)
                s_strTIFFFILE = ""
                TextFILE.Text = ""
            End If

            '-------------------------------------------------------------
            ' プリンタドライバ動作設定値(レジストリ)を元に戻します。

            If s_bGetOldReg = True Then
                Call SFCSENV_WriteSvcRegString("OutFolder", s_strOldOutFolder)
                Call SFCSENV_WriteSvcRegString("DocName", s_strOldDocName)
                Call SFCSENV_WriteRegInt("ExecFlag", s_lOldExecFlag)
                s_bGetOldReg = False
            End If

        End If

    End Sub

    '*************************************************************
    ' [参照]ボタン: クリック
    '*************************************************************

    Private Sub CommandCMNFOLDER_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandCMNFOLDER.Click

        Dim fbd As New FolderBrowserDialog

        '上部に表示する説明テキストを指定する
        fbd.Description = "共有ファルダ"
        'ダイアログを表示する
        If fbd.ShowDialog(Me) = DialogResult.OK Then
            '選択されたフォルダを表示する
            TextCMNFOLDER.Text = fbd.SelectedPath
        End If

    End Sub

    '*************************************************************
    ' [ＦＡＸ原稿の作成]ボタン: クリック
    '*************************************************************

    Private Sub CommandPRINT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandPRINT.Click

        '-------------------------------------------------------------
        ' FAX原稿( TIFFファイル )のクリア

        If s_strTIFFFILE <> "" Then
            Kill(s_strTIFFFILE)
            s_strTIFFFILE = ""
            TextFILE.Text = ""
        End If

        '-------------------------------------------------------------
        ' STARFAX 印刷: ファイル出力フォルダ内のクリア

        If SFCSPRN_ClearOutFolder(s_strOutFolder, CLIAPR2_DOCNAME) = False Then
            MsgBox("ファイル出力フォルダ内のクリアに失敗しました", MsgBoxStyle.Critical, s_cstTITLE)
            Exit Sub
        End If

        System.Windows.Forms.Application.DoEvents()

        Cursor = System.Windows.Forms.Cursors.WaitCursor ' 砂時計

        '-------------------------------------------------------------
        ' サンプル印刷

        Call PROC_SamplePrint((TextTEXT.Text))

        Cursor = System.Windows.Forms.Cursors.Default ' 標準

        '-------------------------------------------------------------
        ' STARFAX 印刷: ファイル出力フォルダ内の印刷完了ファイルの取得

        Dim iRetry As Integer
        Dim strGetFileName As String
        Dim bGet As Boolean

        Cursor = System.Windows.Forms.Cursors.WaitCursor ' 砂時計

        bGet = False

        For iRetry = 1 To 30

            strGetFileName = SFCSPRN_GetPrintFileName(s_strOutFolder, CLIAPR2_DOCNAME)
            If strGetFileName <> "" Then

                '-------------------------------------------------------------
                ' FAX原稿( TIFFファイル )の取得

                s_strTIFFFILE = s_strPgmData & "\" & Dir(strGetFileName)
                Call FileCopy(strGetFileName, s_strTIFFFILE)
                Kill(strGetFileName)
                TextFILE.Text = s_strTIFFFILE

                bGet = True
                Exit For
            End If

            Sleep(2000)

        Next iRetry

        Cursor = System.Windows.Forms.Cursors.Default ' 標準

        If bGet = False Then
            MsgBox("印刷処理が失敗しました", MsgBoxStyle.Critical, s_cstTITLE)
        End If

    End Sub

    '*************************************************************
    ' [ＦＡＸ送信依頼]ボタン: クリック
    '*************************************************************

    Private Sub CommandOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandOK.Click

        Dim strFilePath As String
        Dim strTMP As String ' ＦＡＸ送信依頼ファイル名 (仮作成ファイル)
        Dim strINI As String ' ＦＡＸ送信依頼ファイル名

        Dim strTiffName As String
        Dim strTiffPath As String

        '-------------------------------------------------------------
        ' 共有フォルダ入力チェック

        If TextCMNFOLDER.Text = "" Then
            MsgBox("共有フォルダが指定されていません。", MsgBoxStyle.Critical, s_cstTITLE)
            Exit Sub
        End If

        If TextCMNFOLDER.Text = "\\サーバーマシン名\Work" Then
            MsgBox("共有フォルダが指定されていません。", MsgBoxStyle.Critical, s_cstTITLE)
            Exit Sub
        End If

        '-------------------------------------------------------------
        ' FAX番号

        If TextFAX.Text = "" Then
            MsgBox("FAX番号を指定してください", MsgBoxStyle.Exclamation, s_cstTITLE)
            Exit Sub
        End If

        '-------------------------------------------------------------
        ' 原稿
        If s_strTIFFFILE = "" Then
            MsgBox("[ＦＡＸ原稿の作成] を行ってください", MsgBoxStyle.Exclamation, s_cstTITLE)
            Exit Sub
        End If

        '-------------------------------------------------------------
        ' ＦＡＸ送信依頼ファイル名 作成
        '
        ' 一時ファイル名パスを取得 【重要】
        '
        '  ＦＡＸ送信依頼ファイル名の形式は、INIファイル形式なので、ファイルの書き出しは、
        '  WritePrivateProfileString()【Win32API】 を使用します。
        '  サーバー側プログラムが中途半端な状態で読み出すおそれがあります。それを防ぐ為に、
        '  一旦、一時ファイルを作成し、それをリネームするようにします。
        '

        strFilePath = TextCMNFOLDER.Text
        If Microsoft.VisualBasic.Right(strFilePath, 1) <> "\" Then strFilePath = strFilePath & "\"
        strFilePath = strFilePath & s_strCompName & Format(Now, "YYMMDDhhmmss")
        strTMP = strFilePath & ".TMP"
        If Dir(strTMP) <> "" Then
            Kill(strTMP)
        End If
        strINI = strFilePath & ".INI"
        If Dir(strINI) <> "" Then
            Kill(strINI)
        End If
        strTiffPath = strFilePath & ".TIF"
        If Dir(strTiffPath) <> "" Then
            Kill(strTiffPath)
        End If

        '-------------------------------------------------------------
        ' ＦＡＸ送信依頼ファイル 作成

        Call MoveFile(s_strTIFFFILE, strTiffPath)

        strTiffName = Dir(strTiffPath)

        If WritePrivateProfileString("DOC", "FILE", strTiffName, strTMP) = False Then
            MsgBox("ＦＡＸ送信依頼ファイルの書き込みに失敗しました。", MsgBoxStyle.Critical, s_cstTITLE)
            If Dir(strTMP) <> "" Then
                Kill(strTMP)
            End If
            If Dir(strTiffPath) <> "" Then
                Kill(strTiffPath)
            End If
            Exit Sub
        End If

        If WritePrivateProfileString("FAX", "NO", TextFAX.Text, strTMP) = False Then
            MsgBox("ＦＡＸ送信依頼ファイルの書き込みに失敗しました。", MsgBoxStyle.Critical, s_cstTITLE)
            If Dir(strTMP) <> "" Then
                Kill(strTMP)
            End If
            If Dir(strTiffPath) <> "" Then
                Kill(strTiffPath)
            End If
            Exit Sub
        End If

        Call MoveFile(strTMP, strINI)

        MsgBox("サーバーにＦＡＸ送信を依頼しました。", MsgBoxStyle.OkOnly, s_cstTITLE)

        '-------------------------------------------------------------
        ' FAX番号 クリア

        TextFAX.Text = ""

        '-------------------------------------------------------------
        ' FAX原稿( TIFFファイル )のクリア

        ' 印刷結果ファイルは、STARFAX が削除します。
        s_strTIFFFILE = ""
        TextFILE.Text = ""

        '-------------------------------------------------------------
        ' 共有フォルダ保存

        SaveSetting("CliApr2", "Setting", "CMNFOLDER", TextCMNFOLDER.Text)

    End Sub
End Class
